package com.sun.org.apache.xalan.internal.xsltc.compiler.util;

import java.util.Iterator;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Set;
import java.util.Map;

public final class MultiHashtable<K, V>
{
    static final long serialVersionUID = -6151608290510033572L;
    private final Map<K, Set<V>> map;
    private boolean modifiable;
    
    public MultiHashtable() {
        this.map = new HashMap();
        this.modifiable = true;
    }
    
    public Set<V> put(K key, V value) {
        if (this.modifiable) {
            Set<V> set = (Set)this.map.get(key);
            if (set == null) {
                set = new HashSet();
                this.map.put(key, set);
            }
            set.add(value);
            return set;
        }
        else {
            throw new UnsupportedOperationException("The MultiHashtable instance is not modifiable.");
        }
    }
    
    public V maps(K key, V value) {
        if (key == null) {
            return null;
        }
        Set<V> set = (Set)this.map.get(key);
        if (set != null) {
            for (V v : set) {
                if (v.equals(value)) {
                    return v;
                }
                continue;
            }
        }
        return null;
    }
    
    public void makeUnmodifiable() {
        this.modifiable = false;
    }
}
